package com.xhly.manageapp.utils

import com.xhly.corelib.Const
import com.xhly.manageapp.ManageApplication
import com.xhly.manageapp.bean.strategy.StrategyBean

object StrategyUtils {
    public fun setStrategy(strategyBean: StrategyBean) {
        //是否启用白名单
        if (strategyBean.haswifi == 1) {
            ManageApplication.enableWifiWhiteList(true)
            strategyBean.wifis?.let {
                val list = arrayListOf<String>()
                it.forEach { s ->
                    if (!s.isNullOrBlank()) {
                        list.add(s)
                    }
                }
                ManageApplication.addWifiWhiteList(list)
            }
        } else {
            ManageApplication.enableWifiWhiteList(false)
        }
        //是否开启应用策略
        if (strategyBean.hasapp == 1) {
            //开启
            strategyBean.apps?.let { appArray ->
                val list = arrayListOf<String>()
                appArray.forEach {
                    list.add(it.appPackage)
                }
                ManageApplication.addInstallPackageWhiteList(list)
            }
        } else {
            //不开启应用策略
            val installPackageWhiteList = ManageApplication.getInstallPackageWhiteList()
            ManageApplication.removeInstallPackageWhiteList(installPackageWhiteList)
        }
        //是否开启时间策略
        if (strategyBean.hastime == 1) {
            var currentTimeMillis = System.currentTimeMillis()

        } else {

        }

        //是否设备策略
        if (strategyBean.hasdevice == 1) {
            //开启
            deviceStrategy(strategyBean)
        } else {
            //不设置则默认全部打开
            deviceStrategy(strategyBean)
        }

        //违规处理,直接在事件触发时判断，不再这里处理
        if (strategyBean.hasviolate==1){

        }


    }

    private fun deviceStrategy(strategyBean: StrategyBean) {
        val padDevices = strategyBean.padDevices
        padDevices?.forEach {
            when (it.pdtype) {
                Const.DEVICETYPE1 -> {
                    ManageApplication.disableCamera(it.enabled == 1)
                }

                Const.DEVICETYPE2 -> {
                    ManageApplication.enableBluetooth(it.enabled == 1)
                }

                Const.DEVICETYPE3 -> {
                    ManageApplication.disallowUsbDebugging(it.enabled == 1)
                }

                Const.DEVICETYPE4 -> {
                    ManageApplication.enableWifi(it.enabled == 1)
                }

                Const.DEVICETYPE5 -> {

                }

                Const.DEVICETYPE6 -> {
                    ManageApplication.enableData(it.enabled == 1)
                }

                Const.DEVICETYPE7 -> {
                    ManageApplication.enableLocation(it.enabled == 1)
                }

                Const.DEVICETYPE8 -> {
                    ManageApplication.disallowWifiAdvanceSettings(it.enabled != 1)
                }

                Const.DEVICETYPE9 -> {
                    ManageApplication.enableMassStorage(it.enabled == 1)
                }

                Const.DEVICETYPE10 -> {
                    ManageApplication.setCustomOTG(it.enabled == 1)
                }
            }
        }
    }

    public fun getAppTimeStrategy() {

    }
}